//REMEMBER CHECKSKYHIT EXISTS IN 2.2.14


//Initializing vars
local dashFrames = 0
local vertVal = nil
local useShield = 0



//Start dash when using ability
addHook("AbilitySpecial", function(player)
	if player.mo.skin == "forest"
	and not (player.pflags & PF_THOKKED)
		
		player.thokked = 1
		player.dashing = 1
		player.drawangle = player.mo.angle
		S_StartSound(player.mo, sfx_rail1)
		if player.powers[pw_super]
			dashFrames = 3*TICRATE
			/*if (player.cmd.forwardmove) > 0
				P_StartQuake(20*FRACUNIT, TICRATE/4)
				S_StartSound(player.mo, sfx_kc3b)
			end*/
		else
			dashFrames = TICRATE
		end
		//Shield extras
		if (player.cmd.buttons & BT_SPIN)
			if player.powers[pw_super]
				useShield = 1
			elseif (player.powers[pw_shield] & SH_WHIRLWIND)
				useShield = 1
				if (player.powers[pw_shield] & SH_PROTECTELECTRIC)
					P_DoJumpShield(player)
					S_StartSound(player.mo, sfx_laser)
				else
					S_StartSound(player.mo, sfx_wdjump)
				end
			elseif (player.powers[pw_shield] & SH_PROTECTFIRE)
				useShield = 1
				S_StartSound(player.mo, sfx_s3k43)
				S_StartSound(player.mo, sfx_s3kc2s)
				dashFrames = TICRATE/2
			elseif (player.powers[pw_shield] & SH_PROTECTELECTRIC)
				useShield = 1
				S_StartSound(player.mo, sfx_s3ka6)
				S_StartSound(player.mo, sfx_laser)
			elseif (player.powers[pw_shield] & SH_FORCE)
				useShield = 1
				S_StartSound(player.mo, sfx_ngskid)
				S_StartSound(player.mo, sfx_laser)
				if (player.powers[pw_shield] & SH_FORCEHP)
					dashFrames = $*3
				else
					dashFrames = $*2
				end
			else
				useShield = 0
				S_StartSound(player.mo, sfx_kc5b)
				S_StartSound(player.mo, sfx_laser)
			end
		else
			useShield = 0
			if not player.powers[pw_super]
				S_StartSound(player.mo, sfx_kc5b)
				S_StartSound(player.mo, sfx_laser)
			end
		end
		if useShield
		and (player.powers[pw_shield] & SH_FORCE)
		and not player.powers[pw_super]
			P_InstaThrust(player.mo, player.mo.angle, player.speed*3/4)
		else
			P_InstaThrust(player.mo, player.mo.angle, player.actionspd*player.waterSpeedMul/2)
		end
		P_SpawnTechTrail(player, useShield)
		P_SetObjectMomZ(player.mo, 0)
		player.pflags = $1|PF_THOKKED
		//kc38
		//kc37
		
		//Setting z in case of speed dashing
		if vertVal != nil
			S_StartSound(player.mo, sfx_s3kc3s)
			player.mo.z = vertVal
			if FixedHypot(player.mo.momx, player.mo.momy) > 45*FRACUNIT
				P_InstaThrust(player.mo, R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy), 45*FRACUNIT)
			end
		end
		
	end
end,MT_PLAYER)



//Resetting ability and launching player
local function PlayerLaunch(mobj,mo)
	if dashFrames
	and (mo.player.pflags & ~PF_THOKKED)
		dashFrames = 0
		mo.z = mobj.z + 20*FRACUNIT
		if (mo.player.cmd.buttons & BT_JUMP)
			mo.player.curled = 0
			mo.player.curling = 1
			mo.player.pflags = $|PF_STARTJUMP
			if mo.player.speed < 45*FRACUNIT *mo.player.waterSpeedMul/2
				P_InstaThrust(mo, R_PointToAngle2(0, 0, mo.momx, mo.momy), 45*FRACUNIT *mo.player.waterSpeedMul/2)
			else
				P_Thrust(mo, R_PointToAngle2(0, 0, mo.momx, mo.momy), 9*FRACUNIT)
			end
			if mo.momz * P_MobjFlip(mo) < 0
				P_SetObjectMomZ(mo, 0)
			end
			
			//Launching higher if hit springshell
			if mobj.type == MT_SPRINGSHELL
			or mobj.type == MT_YELLOWSHELL
				P_SetObjectMomZ(mo, 23*mo.player.zWaterMul)
				S_StartSound(mo, sfx_sprong)
			else
				P_SetObjectMomZ(mo, 20*mo.player.zWaterMul)
			end
			//14
			S_StartSound(mo, sfx_s3k40)
			
			//Enemy sumoing
			if (mobj.flags & MF_ENEMY)
				P_InstaThrust(mobj, R_PointToAngle2(0, 0, mo.momx, mo.momy), -20*FRACUNIT)
				P_SetObjectMomZ(mobj, 5*mo.player.zWaterMul)
			end
		else
			mo.player.curled = 0
			mo.player.curling = 1
			if (mo.player.cmd.forwardmove > 0)
				P_InstaThrust(mo, R_PointToAngle2(0, 0, mo.momx, mo.momy), 6*FRACUNIT)
			else
				P_InstaThrust(mo, R_PointToAngle2(0, 0, mo.momx, mo.momy), 2*FRACUNIT)
			end
			P_SetObjectMomZ(mo, 12*mo.player.zWaterMul)
			//9
			S_StartSound(mo, sfx_cybdth)
			
			//Enemy sumoing
			if (mobj.flags & MF_ENEMY)
				P_InstaThrust(mobj, R_PointToAngle2(0, 0, mo.momx, mo.momy), -6*FRACUNIT)
				P_SetObjectMomZ(mobj, 5*mo.player.zWaterMul)
			end
		end
		if mobj.type == MT_SNAILER
			P_SetObjectMomZ(mo, 7*mo.player.zWaterMul, true)
		end
		vertVal = mo.z + 10*FRACUNIT
		mo.player.drawangle = R_PointToAngle2(0, 0, mo.momx, mo.momy)
		mo.player.launching = 2
	end
	mo.player.thokked = 0
	mo.player.pflags = $&~PF_THOKKED
end



//Reset ability and goes up if player damages enemy or boss
addHook("MobjDamage", function(mobj,mo)
	if (mo and mo.valid and mo.skin == "forest")
	and not P_IsObjectOnGround(mo)
	and (mobj.flags & (MF_ENEMY|MF_BOSS))
		PlayerLaunch(mobj,mo)
	end
end)



//Reset ability and goes up if player damages monitor
addHook("MobjDeath", function(mobj,mo)
	if (mo and mo.valid and mo.skin == "forest")
	and not P_IsObjectOnGround(mo)
	and (mobj.flags & MF_MONITOR)
		PlayerLaunch(mobj,mo)
	end
end)



addHook("PlayerThink", function(player)
	if player.mo.skin == "forest"
	
		//Initializing relevant player vars
		if player.thokked == nil
			player.thokked = 0
			player.dashing = 0
			player.waterSpeedMul = 2
			player.launching = 0
		end
		if player.mo.eflags & MFE_UNDERWATER
			player.waterSpeedMul = 1
		else
			player.waterSpeedMul = 2
		end
		if player.launching > 0
			player.launching = $-1
		end
		
		
		//Homing reticle
		if (((player.powers[pw_shield] & SH_PROTECTELECTRIC)
		and not (player.powers[pw_shield] & SH_WHIRLWIND)) or player.powers[pw_super])
		and P_LookForEnemies(player, true, true)
		and not P_IsObjectOnGround(player.mo)
		and not ((player.pflags & PF_THOKKED) and not player.dashing)
			P_SpawnLockOn(player, P_LookForEnemies(player, true, true), S_LOCKON2)
		end
		
		
		//Setting thok speed (using momz as a boost)
		local vertBoost = FixedMul(player.mo.momz, FRACUNIT/-32768*P_GetMobjGravity(player.mo))
		local baseSpeed = 20*FRACUNIT
		if player.powers[pw_super]
			if (player.cmd.forwardmove) > 0
				baseSpeed = 70*FRACUNIT
			end
		elseif (player.cmd.buttons & BT_SPIN)
		and (player.powers[pw_shield] & SH_PROTECTFIRE)
			baseSpeed = 55*FRACUNIT
		end
		if (vertBoost > 0
		and (player.speed*2/player.waterSpeedMul + vertBoost > baseSpeed + 5*FRACUNIT))
		or (vertBoost <= 0
		and (player.speed*2/player.waterSpeedMul > baseSpeed + 5*FRACUNIT))
			if vertBoost > 0
				player.actionspd = player.speed*2/player.waterSpeedMul + vertBoost - 5*FRACUNIT
				//print("boost")
				//print(FixedInt(player.actionspd))
			else
				player.actionspd = player.speed*2/player.waterSpeedMul - 5*FRACUNIT
				//print("no boost")
				//print(FixedInt(player.actionspd))
			end
		else
			if vertBoost > 0
				player.actionspd = baseSpeed + vertBoost
			else
				player.actionspd = baseSpeed
			end
		end
		
		
		//Make it so you're not speed dashing
		if player.curling == player.curled
			vertVal = nil
		end
		
		//If you are launching, gravity gets a bit heavier
		if vertVal and (player.mo.momz*P_GetMobjGravity(player.mo) > 0)
			player.mo.momz = $ + P_GetMobjGravity(player.mo)*2
		end
		
		//Checks to keep dash
		if not player.exiting
		and player.mo.health
		and not (P_PlayerInPain(player))
		and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
		and not player.powers[pw_carry]
		and not P_IsObjectOnGround(player.mo)
		and not player.powers[pw_carry]
		and not (player.mo.eflags & MFE_SPRUNG)
			if dashFrames > TICRATE/2
			and player.dashing == 1
				if not (player.cmd.buttons & BT_JUMP)
					player.dashing = 0
				end
				dashFrames = $ - 1
				
				//Super dash
				if player.powers[pw_super]
					player.thrustfactor = 16
					
					//Low time remaining warning
					if dashFrames == TICRATE/2
						S_StartSound(player.mo, sfx_kc65)
					elseif not (leveltime % 2) and dashFrames <= TICRATE*3/2
						S_StartSoundAtVolume(player.mo, sfx_deton, 64)
					end
					
					//States and tech trail
					if player.speed > player.runspeed
						if dashFrames > TICRATE*3/2
						or not (leveltime % 2)
							P_SpawnTechTrail(player, false)
						end
						if player.mo.state != S_PLAY_FLOAT_RUN
							player.mo.state = S_PLAY_FLOAT_RUN
						end
					else
						if player.mo.state != S_PLAY_FLOAT
							player.mo.state = S_PLAY_FLOAT
						end
					end
					
					//Flight control (up and down)
					if (player.cmd.buttons & BT_SPIN)
						dashFrames = $ - 1
						if FixedMul(player.mo.momz, FRACUNIT/-32768*P_GetMobjGravity(player.mo)) < 10*FRACUNIT
							P_SetObjectMomZ(player.mo, 2*FRACUNIT, true)
						else
							P_SetObjectMomZ(player.mo, 10*FRACUNIT)
						end
						//if FixedHypot(player.mo.momx, player.mo.momy) > player.normalspeed
							P_Thrust(player.mo, R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy), -FixedHypot(player.mo.momx, player.mo.momy)/96)
							//-FRACUNIT*3/4
						//end
					elseif (player.cmd.buttons & BT_CUSTOM1)
						if FixedMul(player.mo.momz, FRACUNIT/-32768*P_GetMobjGravity(player.mo)) > -5*FRACUNIT
							P_SetObjectMomZ(player.mo, -FRACUNIT/2, true)
						else
							P_SetObjectMomZ(player.mo, -5*FRACUNIT)
						end
					else
						P_SetObjectMomZ(player.mo, 0)
					end
					
					//"Friction"
					if not (player.cmd.forwardmove or player.cmd.sidemove)
						P_Thrust(player.mo, R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy), -FixedHypot(player.mo.momx, player.mo.momy)/32)
					end
					
					//Homing attack
					if useShield
						if P_LookForEnemies(player, true, true)
							P_HomingAttack(player.mo, P_LookForEnemies(player, true, true))
							player.mo.momx = $*3/2
							player.mo.momy = $*3/2
							player.mo.momz = $*3/2
						else
							useShield = 0
						end
					end
					
				//Normal dash
				else
					//Resetting from super (and normal tech trail)
					if not ((player.powers[pw_shield] & SH_FORCE) and useShield)
						P_SpawnTechTrail(player, useShield)
						if dashFrames > TICRATE
							dashFrames = TICRATE
						end
					end
					
					//Shield hovering
					if useShield
						if (player.powers[pw_shield] & SH_WHIRLWIND)
							P_SetObjectMomZ(player.mo, 6*FRACUNIT)
						elseif (player.powers[pw_shield] & SH_PROTECTELECTRIC)
							if P_LookForEnemies(player, true, true)
								P_HomingAttack(player.mo, P_LookForEnemies(player, true, true))
							else
								dashFrames = 0
							end
						else
							if (player.powers[pw_shield] & SH_FORCE)
								if dashFrames == TICRATE/2
									S_StartSound(player.mo, sfx_kc65)
								elseif not (leveltime % 2) and dashFrames <= TICRATE*3/2
									S_StartSoundAtVolume(player.mo, sfx_deton, 64)
								end
								if dashFrames > TICRATE*3/2
								or not (leveltime % 2)
									P_SpawnTechTrail(player, useShield)
								end
								player.thrustfactor = 6
							end
							P_SetObjectMomZ(player.mo, 0)
						end
					else
						P_SetObjectMomZ(player.mo, 0)
					end
					
				end
				//ghost.blendmode = AST_SUBTRACT
			elseif dashFrames
			and not (player.cmd.buttons & BT_CUSTOM1)
				dashFrames = $ - 1
				player.dashing = 0
			else
				dashFrames = 0
				player.dashing = 0
			end
		else
			dashFrames = 0
		end
		
		//Fix dashing effects if not dashing
		if not player.dashing
			S_StopSoundByID(player.mo, sfx_laser)
		end
		
		//Fixing thrustfactor after hovering
		if not player.dashing
			player.thrustfactor = 4
		end
		
		//Reset thok if ground is hit (not dashing either)
		if P_IsObjectOnGround(player.mo)
			player.dashing = 0
			player.thokked = 0
		end
		if (player.mo.eflags & MFE_JUSTHITFLOOR)
			player.dashing = 0
			player.thokked = 0
		end
		
	end
end,MT_PLAYER)