// Modified from Krabs' Anglestand v1
// Modified by Stonecutter

freeslot("S_PLAY_ANGLEIDLE")
states[S_PLAY_ANGLEIDLE] = {SPR_PLAY, SPR2_WAIT, 16, nil, 0, 0, S_PLAY_ANGLEIDLE}

addHook("ThinkFrame", function(player)
	for player in players.iterate()
	if player.mo and player.mo.skin == "forest"
		if player.mo and player.mo.valid and player.playerstate == PST_LIVE
			local mo = player.mo
			
			local initialState = mo.state
			if player.prevdrawangle
			    if (initialState == S_PLAY_WAIT)
				    mo.state = S_PLAY_ANGLEIDLE
			    elseif (initialState == S_PLAY_STND or initialState == S_PLAY_ANGLEIDLE)
				    player.drawangle = player.prevdrawangle
			        if(player.idlewait != nil)
						local idlewait = player.idlewait
				        if(idlewait < 5 * TICRATE)
					        player.idlewait = $ + 1
					    else
					        if(idlewait < 5 * TICRATE + 1)
						        mo.state = S_PLAY_ANGLEIDLE
							    player.idlewait = $ + 1
						    end
						end
						
				    else
					    player.idlewait = 1
				    end
				elseif
				(
					(mo.state == S_PLAY_JUMP and mo.momx == 0 and mo.momy == 0)
					or (mo.state == S_PLAY_EDGE and player.rmomx == 0 and player.rmomy == 0)
				)
				    player.drawangle = player.prevdrawangle
					player.idlewait = 0
				else
				    player.idlewait = 0
				end
			end
			
			player.prevdrawangle = player.drawangle
			if (player.rmomx == 0 and player.rmomy == 0)
			elseif(initialState == S_PLAY_ANGLEIDLE)
			    mo.state = S_PLAY_WALK
			end
		end
	end
	end
end)

addHook("MapLoad", function()
	for player in players.iterate()
		if player.mo and player.mo.valid
		and player.mo.skin == "forest"
			player.prevdrawangle = player.mo.angle
			player.idlewait = 0
		end
	end
end)